/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __IPC_RUNNER_PUBLIC_H__
#define __IPC_RUNNER_PUBLIC_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.gnome.Retro.Runner */

#define IPC_TYPE_RUNNER (ipc_runner_get_type ())
#define IPC_RUNNER(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), IPC_TYPE_RUNNER, IpcRunner))
#define IPC_IS_RUNNER(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), IPC_TYPE_RUNNER))
#define IPC_RUNNER_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), IPC_TYPE_RUNNER, IpcRunnerIface))

struct _IpcRunner;
typedef struct _IpcRunner IpcRunner;
typedef struct _IpcRunnerIface IpcRunnerIface;

struct _IpcRunnerIface
{
  GTypeInterface parent_iface;



  gboolean (*handle_boot) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list,
    GVariant *arg_defaults,
    const gchar *const *arg_medias,
    GVariant *arg_default_controller);

  gboolean (*handle_get_can_access_state) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_get_memory_size) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    guint arg_memory_type);

  gboolean (*handle_get_properties) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_iteration) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_key_event) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    gboolean arg_pressed,
    guint arg_keycode,
    guint arg_character,
    guint arg_modifiers);

  gboolean (*handle_load_memory) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    guint arg_memory_type,
    const gchar *arg_filename);

  gboolean (*handle_load_state) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_filename);

  gboolean (*handle_reset) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_run) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_save_memory) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    guint arg_memory_type,
    const gchar *arg_filename);

  gboolean (*handle_save_state) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_filename);

  gboolean (*handle_set_controller) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list,
    guint arg_port,
    guint arg_type,
    GVariant *arg_data);

  gboolean (*handle_set_current_media) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    guint arg_index);

  gboolean (*handle_stop) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_update_variable) (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_key,
    const gchar *arg_value);

  guint  (*get_api_version) (IpcRunner *object);

  const gchar * (*get_content_directory) (IpcRunner *object);

  gdouble  (*get_frames_per_second) (IpcRunner *object);

  gboolean  (*get_game_loaded) (IpcRunner *object);

  guint  (*get_runahead) (IpcRunner *object);

  const gchar * (*get_save_directory) (IpcRunner *object);

  gdouble  (*get_speed_rate) (IpcRunner *object);

  gboolean  (*get_support_no_game) (IpcRunner *object);

  const gchar * (*get_system_directory) (IpcRunner *object);

  void (*log) (
    IpcRunner *object,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message);

  void (*message) (
    IpcRunner *object,
    const gchar *arg_message,
    guint arg_frames);

  void (*set_rumble_state) (
    IpcRunner *object,
    guint arg_port,
    guint arg_type,
    guint16 arg_strength);

  void (*variables_set) (
    IpcRunner *object,
    GVariant *arg_data);

  void (*video_output) (
    IpcRunner *object);

};

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IpcRunner, g_object_unref)
#endif

GType ipc_runner_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *ipc_runner_interface_info (void);
guint ipc_runner_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void ipc_runner_complete_get_properties (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    gboolean game_loaded,
    gdouble fps,
    gboolean support_no_game);

void ipc_runner_complete_boot (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list,
    GVariant *variables,
    GVariant *framebuffer);

void ipc_runner_complete_set_current_media (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_run (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_stop (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_reset (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_iteration (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_get_can_access_state (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    gboolean can_access_state);

void ipc_runner_complete_save_state (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_load_state (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_get_memory_size (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    guint64 size);

void ipc_runner_complete_save_memory (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_load_memory (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_update_variable (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);

void ipc_runner_complete_set_controller (
    IpcRunner *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list);

void ipc_runner_complete_key_event (
    IpcRunner *object,
    GDBusMethodInvocation *invocation);



/* D-Bus signal emissions functions: */
void ipc_runner_emit_variables_set (
    IpcRunner *object,
    GVariant *arg_data);

void ipc_runner_emit_set_rumble_state (
    IpcRunner *object,
    guint arg_port,
    guint arg_type,
    guint16 arg_strength);

void ipc_runner_emit_video_output (
    IpcRunner *object);

void ipc_runner_emit_log (
    IpcRunner *object,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message);

void ipc_runner_emit_message (
    IpcRunner *object,
    const gchar *arg_message,
    guint arg_frames);



/* D-Bus method calls: */
void ipc_runner_call_get_properties (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_get_properties_finish (
    IpcRunner *proxy,
    gboolean *out_game_loaded,
    gdouble *out_fps,
    gboolean *out_support_no_game,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_get_properties_sync (
    IpcRunner *proxy,
    gboolean *out_game_loaded,
    gdouble *out_fps,
    gboolean *out_support_no_game,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_boot (
    IpcRunner *proxy,
    GVariant *arg_defaults,
    const gchar *const *arg_medias,
    GVariant *arg_default_controller,
    GUnixFDList *fd_list,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_boot_finish (
    IpcRunner *proxy,
    GVariant **out_variables,
    GVariant **out_framebuffer,
    GUnixFDList **out_fd_list,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_boot_sync (
    IpcRunner *proxy,
    GVariant *arg_defaults,
    const gchar *const *arg_medias,
    GVariant *arg_default_controller,
    GUnixFDList  *fd_list,
    GVariant **out_variables,
    GVariant **out_framebuffer,
    GUnixFDList **out_fd_list,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_set_current_media (
    IpcRunner *proxy,
    guint arg_index,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_set_current_media_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_set_current_media_sync (
    IpcRunner *proxy,
    guint arg_index,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_run (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_run_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_run_sync (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_stop (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_stop_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_stop_sync (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_reset (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_reset_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_reset_sync (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_iteration (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_iteration_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_iteration_sync (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_get_can_access_state (
    IpcRunner *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_get_can_access_state_finish (
    IpcRunner *proxy,
    gboolean *out_can_access_state,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_get_can_access_state_sync (
    IpcRunner *proxy,
    gboolean *out_can_access_state,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_save_state (
    IpcRunner *proxy,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_save_state_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_save_state_sync (
    IpcRunner *proxy,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_load_state (
    IpcRunner *proxy,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_load_state_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_load_state_sync (
    IpcRunner *proxy,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_get_memory_size (
    IpcRunner *proxy,
    guint arg_memory_type,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_get_memory_size_finish (
    IpcRunner *proxy,
    guint64 *out_size,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_get_memory_size_sync (
    IpcRunner *proxy,
    guint arg_memory_type,
    guint64 *out_size,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_save_memory (
    IpcRunner *proxy,
    guint arg_memory_type,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_save_memory_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_save_memory_sync (
    IpcRunner *proxy,
    guint arg_memory_type,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_load_memory (
    IpcRunner *proxy,
    guint arg_memory_type,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_load_memory_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_load_memory_sync (
    IpcRunner *proxy,
    guint arg_memory_type,
    const gchar *arg_filename,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_update_variable (
    IpcRunner *proxy,
    const gchar *arg_key,
    const gchar *arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_update_variable_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_update_variable_sync (
    IpcRunner *proxy,
    const gchar *arg_key,
    const gchar *arg_value,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_set_controller (
    IpcRunner *proxy,
    guint arg_port,
    guint arg_type,
    GVariant *arg_data,
    GUnixFDList *fd_list,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_set_controller_finish (
    IpcRunner *proxy,
    GUnixFDList **out_fd_list,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_set_controller_sync (
    IpcRunner *proxy,
    guint arg_port,
    guint arg_type,
    GVariant *arg_data,
    GUnixFDList  *fd_list,
    GUnixFDList **out_fd_list,
    GCancellable *cancellable,
    GError **error);

void ipc_runner_call_key_event (
    IpcRunner *proxy,
    gboolean arg_pressed,
    guint arg_keycode,
    guint arg_character,
    guint arg_modifiers,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean ipc_runner_call_key_event_finish (
    IpcRunner *proxy,
    GAsyncResult *res,
    GError **error);

gboolean ipc_runner_call_key_event_sync (
    IpcRunner *proxy,
    gboolean arg_pressed,
    guint arg_keycode,
    guint arg_character,
    guint arg_modifiers,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
guint ipc_runner_get_api_version (IpcRunner *object);
void ipc_runner_set_api_version (IpcRunner *object, guint value);

const gchar *ipc_runner_get_system_directory (IpcRunner *object);
gchar *ipc_runner_dup_system_directory (IpcRunner *object);
void ipc_runner_set_system_directory (IpcRunner *object, const gchar *value);

const gchar *ipc_runner_get_content_directory (IpcRunner *object);
gchar *ipc_runner_dup_content_directory (IpcRunner *object);
void ipc_runner_set_content_directory (IpcRunner *object, const gchar *value);

const gchar *ipc_runner_get_save_directory (IpcRunner *object);
gchar *ipc_runner_dup_save_directory (IpcRunner *object);
void ipc_runner_set_save_directory (IpcRunner *object, const gchar *value);

gboolean ipc_runner_get_game_loaded (IpcRunner *object);
void ipc_runner_set_game_loaded (IpcRunner *object, gboolean value);

gdouble ipc_runner_get_frames_per_second (IpcRunner *object);
void ipc_runner_set_frames_per_second (IpcRunner *object, gdouble value);

gboolean ipc_runner_get_support_no_game (IpcRunner *object);
void ipc_runner_set_support_no_game (IpcRunner *object, gboolean value);

gdouble ipc_runner_get_speed_rate (IpcRunner *object);
void ipc_runner_set_speed_rate (IpcRunner *object, gdouble value);

guint ipc_runner_get_runahead (IpcRunner *object);
void ipc_runner_set_runahead (IpcRunner *object, guint value);


/* ---- */

#define IPC_TYPE_RUNNER_PROXY (ipc_runner_proxy_get_type ())
#define IPC_RUNNER_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), IPC_TYPE_RUNNER_PROXY, IpcRunnerProxy))
#define IPC_RUNNER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), IPC_TYPE_RUNNER_PROXY, IpcRunnerProxyClass))
#define IPC_RUNNER_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), IPC_TYPE_RUNNER_PROXY, IpcRunnerProxyClass))
#define IPC_IS_RUNNER_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), IPC_TYPE_RUNNER_PROXY))
#define IPC_IS_RUNNER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), IPC_TYPE_RUNNER_PROXY))

typedef struct _IpcRunnerProxy IpcRunnerProxy;
typedef struct _IpcRunnerProxyClass IpcRunnerProxyClass;
typedef struct _IpcRunnerProxyPrivate IpcRunnerProxyPrivate;

struct _IpcRunnerProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  IpcRunnerProxyPrivate *priv;
};

struct _IpcRunnerProxyClass
{
  GDBusProxyClass parent_class;
};

GType ipc_runner_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IpcRunnerProxy, g_object_unref)
#endif

void ipc_runner_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
IpcRunner *ipc_runner_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
IpcRunner *ipc_runner_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void ipc_runner_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
IpcRunner *ipc_runner_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
IpcRunner *ipc_runner_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define IPC_TYPE_RUNNER_SKELETON (ipc_runner_skeleton_get_type ())
#define IPC_RUNNER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), IPC_TYPE_RUNNER_SKELETON, IpcRunnerSkeleton))
#define IPC_RUNNER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), IPC_TYPE_RUNNER_SKELETON, IpcRunnerSkeletonClass))
#define IPC_RUNNER_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), IPC_TYPE_RUNNER_SKELETON, IpcRunnerSkeletonClass))
#define IPC_IS_RUNNER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), IPC_TYPE_RUNNER_SKELETON))
#define IPC_IS_RUNNER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), IPC_TYPE_RUNNER_SKELETON))

typedef struct _IpcRunnerSkeleton IpcRunnerSkeleton;
typedef struct _IpcRunnerSkeletonClass IpcRunnerSkeletonClass;
typedef struct _IpcRunnerSkeletonPrivate IpcRunnerSkeletonPrivate;

struct _IpcRunnerSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  IpcRunnerSkeletonPrivate *priv;
};

struct _IpcRunnerSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType ipc_runner_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IpcRunnerSkeleton, g_object_unref)
#endif

IpcRunner *ipc_runner_skeleton_new (void);


G_END_DECLS

#endif /* __IPC_RUNNER_PUBLIC_H__ */
